<?php
/*
 * Class that is passed when creating a ticket with service "AddServiceTicketViaCompanyId" 
 */
class AddServiceTicketViaCompanyId {
  public $credentials; // ApiCredentials
  public $companyId; // string
  public $serviceTicket; // ServiceTicket
  
  /* constructor to instantiate required arguments */
  public function __construct (ApiCredentials $credentials, $companyId, ServiceTicket $serviceTicket){
    $this->credentials = $credentials;
    $this->companyId = $companyId;
    $this->serviceTicket = $serviceTicket;
  }
}

/*
 * Class that holds the credentials 
 */

class ApiCredentials {
  public $CompanyId; // string
  public $IntegratorLoginId; // string
  public $IntegratorPassword; // string
  
  /* constructor to instantiate required arguments */
   function __construct($x, $y,$z) {
    $this->CompanyId  = $x;
    $this->IntegratorLoginId = $y;
    $this->IntegratorPassword  = $z;
  }
}

/*
 * Class that holds the ticket details 
 */
class ServiceTicket {
  public $TicketNumber = 0; // int
  public $SendingSrServiceRecid =0; // int
  public $DateReq = "0001-01-01T00:00:00"; // dateTime
  public $SubBillingMethodId="Actual"; // SrBillingMethod
  public $SubBillingAmount=0.00; // decimal
  public $SubDateAccepted="0001-01-01T00:00:00"; // dateTime
  public $SubDateAcceptedUtc="0001-01-01T00:00:00"; // dateTime
  public $BudgetHours=0.00; // decimal
  public $SkipCallback=FALSE; // boolean
  public $Approved=FALSE; // boolean
  public $ClosedFlag = FALSE; // boolean
  public $Summary; // string
  public $Board; // string
  public $Status; // NsnStatusId
  public $CompanyId; // string
  public $DetailNotes; //ArrayofTicketNotes
  public $Priority; //string
  public $ProcessNotifications; // boolean
  
  /* constructor to instantiate required arguments */
   public function __construct ($summary, $board, $status, $companyId, $priority, $notif, $tnote){
        $this->Summary = $summary;
        $this->Board = $board;
        $this->Status=$status;
        $this->CompanyId= $companyId;       
        $this->Priority = $priority;
	$this->ProcessNotifications = $notif;
        if ( !empty ($tnote) ) {
                $this->ProblemDescription = $tnote->NoteText; 
                $this->DetailNotes = array($tnote); 
	}
 }
}

class UpdateTicket {
  public $credentials; // ApiCredentials
  public $companyId; // string
  public $ticket;    // Ticket
  
  /* constructor to instantiate required arguments */
  public function __construct (ApiCredentials $credentials, $companyId, Ticket $ticket){
    $this->credentials = $credentials;
    $this->companyId = $companyId;
    $this->ticket = $ticket;
  }
}

class Ticket {
  public $Id = 0; // int 
  public $Summary; // string
  public $Status; // NsnStatusId
  public $DateReq = "0001-01-01T00:00:00"; // dateTime
  public $ProblemDescription; // string
  
  /* constructor to instantiate required arguments */
  public function __construct ($id, $summary, $status, $tnote){
        $this->Id = $id;
        $this->Summary = $summary;
        $this->Status = $status;
	$this->ProblemDescription = $tnote; 
  }
}

/*
 * Class that holds the details for a ticket note 
*/
class TicketNote {
  public $CustomerUpdatedFlag; // boolean
  public $Id; // int
  public $NoteText; // string
  public $PortalIsInternalNote; // boolean
  public $PortalIsExternalNote; // boolean
  public $IsPartOfDetailDescription; // boolean
  public $IsPartOfInternalAnalysis; // boolean
  public $IsPartOfResolution; // boolean
  public $MemberRecID; // int
  public $ContactRecID; // int
  public $DateCreated; // dateTime
  public $CreatedBy; // string
  public $MemberFullName; // string
  
  /* constructor to instantiate required arguments */
   public function __construct ($noteText, $id, $user){
    $this->CustomerUpdatedFlag = 0;
    $this->Id = $id;
    $this->NoteText = $noteText;
    $this->PortalIsInternalNote =0;
    $this->PortalIsExternalNote =1;
    $this->IsPartOfDetailDescription = 1;
    $this->IsPartOfInternalAnalysis =0;
    $this->IsPartOfResolution =0;
    $this->MemberRecID = 0;
    $this->ContactRecID = 0;
    // $this->DateCreated = "2013-04-12T11:02:50.343";
    $this->DateCreated = date(DATE_ATOM);
    $this->CreatedBy = $user;
    //$this->MemberFullName ="";
  }  
}
 
 /*
 * Class that is used when calling the service  "UpdateTicketNote"
 */

class UpdateTicketNote {
  public $credentials; // ApiCredentials
  public $srServiceRecid; // int
  public $note; // TicketNote
  
  /* constructor to instantiate required arguments */
   public function __construct ($credentials, $note, $srServiceRecid){
    $this->credentials = $credentials;
    $this->srServiceRecid = $srServiceRecid;
    $this->note = $note;
 }
}
?>
