#!/bin/sh

. /etc/default/bp.ini 2>/dev/null

PROFILE_SCHEDULES=$BPDIR/profiles.dir/schedules
PROFILE_TEMPLATES=$BPDIR/profiles.dir/templates
PROFILE_DIR=$BPDIR/profiles.dir
SQL_DIR=$PROFILE_SCHEDULES/sql
NEW_SCHED_DIR=schedules
NEW_TEMP_DIR=templates
pushd $PROFILE_DIR 1>/dev/null 2>&1

count=0
while true
do
	if [ -f $NEW_SCHED_DIR -o  -d $NEW_SCHED_DIR ]; then
		NEW_SCHED_DIR="schedules_"$count
	else
		break;
	fi
	count=`expr $count + 1`
done
mkdir $NEW_SCHED_DIR

count=0
while true
do
	if [ -f $NEW_TEMP_DIR -o  -d $NEW_TEMP_DIR ]; then
		NEW_TEMP_DIR="templates_"$count
	else
		break;
	fi
	count=`expr $count + 1`
done
mkdir $NEW_TEMP_DIR

cp -r $PROFILE_SCHEDULES/* $NEW_SCHED_DIR/
cp -r $PROFILE_TEMPLATES/* $NEW_TEMP_DIR/

pushd $NEW_SCHED_DIR 1>/dev/null 2>&1
for file in *.spr ; do
	 if [ ! -f $file ]; then
		 continue
	 fi
	 echo "$file"
	 cat $file | sed 's/[ \t]*$//' > $PROFILE_SCHEDULES/$file
done

pushd sql 1>/dev/null 2>&1
for file in *.spr ; do
	 if [ ! -f $file ]; then
		 continue
	 fi
	 echo "$file"
	 cat $file | sed 's/[ \t]*$//' > $SQL_DIR/$file
done

popd 1>/dev/null 2>&1
popd 1>/dev/null 2>&1

pushd $NEW_TEMP_DIR 1>/dev/null 2>&1
for file in *.spr ; do
	 if [ ! -f $file ]; then
		 continue
	 fi
	 echo "$file"
	 cat $file | sed 's/[ \t]*$//' > $PROFILE_TEMPLATES/$file
done
