#!/bin/sh -u

# Mounts archive media

. /etc/default/bp.ini 2> /dev/null
. ${BPDIR}/bin/uarchive-scripts/constants.incl

. ${BPDIR}/bin/uarchive-scripts/capabilities.incl
. ${BPDIR}/bin/uarchive-scripts/media_3ware.incl
. ${BPDIR}/bin/uarchive-scripts/media_removable.incl
. ${BPDIR}/bin/uarchive-scripts/mount.incl


device="$1"
path="$2"

echo "Identifying and mounting device $device" 1>&2

# Create the mount path, if necessary
if [ ! -d "$path" ]; then
	if [ -f "$path" ]; then
		echo "Mount path '$path' conflicts with an existing file" | $DUP
		exit 1
	fi
	echo "Mount path '$path' not found" 1>&2
	mkdir -p "$path" 1>&2
	if [ $? -ne 0 ]; then
		echo "Error creating mount path '$path'" | $DUP
		exit 1
	fi
	echo "Created mount path" 1>&2
fi

# Mount device
if [[ "$device" = "3ware MDA" ]]; then
	Identify3WareMedia || exit 1
	if [ "$TwMediaFound" != "y" ] || [ "$TwMDA" = "n" ]; then
		echo "The archiving system did not find a 3ware MDA unit connected to the DPU" | $DUP
		exit 1
	fi
elif [[ "$device" = "3ware" ]]; then
	Identify3WareMedia || exit 1
	if [ "$TwMediaFound" != "y" ] || [ "$TwMDA" = "y" ]; then
		echo "The archiving system did not find any removable 3ware drives in the DPU" | $DUP
		exit 1
	fi
fi

MountArchiveDisk "$device" "$path"
ret=$?

#[ "$ret" -ne 0 ] && echo "Failed to mount archive media: already mounted?" | $DUP
[ "$ret" -eq 0 ] && echo "Archive media is mounted at '$path'"
exit $ret

