#!/bin/sh -u

# Unmounts archive media

. /etc/default/bp.ini 2> /dev/null
. ${BPDIR}/bin/uarchive-scripts/capabilities.incl

. ${BPDIR}/bin/uarchive-scripts/constants.incl
. ${BPDIR}/bin/uarchive-scripts/media_3ware.incl
. ${BPDIR}/bin/uarchive-scripts/media_removable.incl
. ${BPDIR}/bin/uarchive-scripts/mount.incl


device="$1"  # "3ware", "3ware MDA", "Recovery Archive", or a device node. If
             # something else is given and force==1 and there's only one hotplug
             # device, it's unmounted.
force="$2"   # 0 to be nice, 1 to kill processes and unmount despite
             # whether the archive process "owns" the mount or not

echo "Identifying and unmounting device $device\n" 1>&2

# Unount device
if [[ "$device" = "3ware MDA" ]]; then
	Identify3WareMedia || exit 1
	if [ "$TwMediaFound" != "y" ] || [ "$TwMDA" = "n" ]; then
		echo "The archiving system did not find a 3ware MDA unit connected to the DPU" | $DUP
		exit 1
	fi
	RemoveArchiveDisk "$device" "$force"
	ret=$?
elif [[ "$device" = "3ware" ]]; then
	Identify3WareMedia || exit 1
	if [ "$TwMediaFound" != "y" ] || [ "$TwMDA" = "y" ]; then
		echo "The archiving system did not find any removable 3ware drives in the DPU" | $DUP
		exit 1
	fi
	RemoveArchiveDisk "$device" "$force"
	ret=$?
else
	RemoveArchiveDisk "$device" "$force"
	ret=$?
fi

[ "$ret" -eq 0 ] && echo "Successfully unmounted $device archive media"
exit $ret

