clear
# This script creates a sql dump file of the specified workspace.
# Args;
# $1 (reqd) - workspace name
# $2 (opt)  - DPU ID, or a single dash ("-") to bypass this argument
#
# unitrends_pgdump.php is invoked in "vaulting" mode, which is the
# only use of this script (for creating/transferring the workspace
# dump to the vault)
#

#2364
USER=`whoami | awk '{print $1}'`
if [ ! "$USER" = "root" ]
then
	echo -e "Error: You must be root to run $0\n"
	exit 1
fi

. /etc/default/bp.ini 2> /dev/null

pushd $BPDIR/bin >/dev/null

if [ $# -lt 1 ]
then
	echo "Usage: $0 <workspace_name> [<dpuid>]"
	php -q -f $BPDIR/bin/unitrends_pgdump.php | tail -n+3 
	exit 0
fi

# The last arg is the dpuid, and is optional
php -q -f $BPDIR/bin/unitrends_pgdump.php vaulting $1 $2
ret=$?
if [ $ret -ne 0 ]
then
	echo "$0: Errors occurred dumping $1."
	popd >/dev/null
	exit $ret
fi

if ! [ -z $1 ]
then
	# If the dpuid was supplied on the command-line,
	# the output file will include it in the name.
	# To supply arg 3 and not 2, use '-' for the second arg
	if [[ -z "$2" || $2 = "-" ]]
	then
		dumpfile=$1.sql
	else
		dumpfile=$1_$2.sql
	fi
	$BPDIR/bin/transfer_sql_dpv.sh $dumpfile
	ret=$?
	popd >/dev/null
	# 2443
	exit $ret
fi

popd >/dev/null
