#!/bin/sh
#
# lcsutil.inc - BP schedule scripts database routines.
#		Primary use is with Before/After commands for the scheduler.
#
#		Source this in your scripts after bpsh.inc
#

PRINTDB=$BPBIN/printdb; export PRINTDB

# variables for use in before/after script routines
#
: ${BP_LCS_TYPES:=""}
: ${BP_LCS_BACKUPS:=""}
: ${BP_LCS_STATUS:=""}
_NEXT_BACKUP=""
_NEXT_STATUS=""
_NEXT_TYPE=""
_lcs_index=0

_BpLcsParseStatus()
{
	[ -z "$BP_LCS_TYPES" ] && return 1
	
	_NEXT_BACKUP=`echo $BP_LCS_BACKUPS | cut -d: -f$_lcs_index`
	_NEXT_STATUS=`echo $BP_LCS_STATUS | cut -d: -f$_lcs_index`
	_NEXT_TYPE=`echo $BP_LCS_TYPES | cut -d: -f$_lcs_index`
	
	return 0
}

BpLcsGetNextStatus()
{
	_lcs_index=`expr $_lcs_index + 1`

	_BpLcsParseStatus
	return $?
}

BpLcsGetFirstStatus()
{
	_lcs_index=1

	_BpLcsParseStatus
	return $?
}
