<?php

class AuditHistory
{
    private $BP;

    public function __construct($BP, $sid)
    {
        $this->BP = $BP;
        $this->now = time();
        $this->sid = $sid;

        require_once('function.lib.php');
        $this->functions = new Functions($this->BP);
    }


    public function get($which)
    {
        $data = array();
        $startDate = isset($_GET['start_date']) ? strtotime($_GET['start_date']) : strtotime(Constants::DATE_ONE_WEEK_AGO);
        $endDate = isset($_GET['end_date']) ? $this->functions->formatEndDate($_GET['end_date']) : strtotime('now');

        if ($this->sid !== false) {
            $filter = array(
                'start_time' => $startDate,
                'end_time' => $endDate
            );

            $audits = $this->BP->get_audit_history($filter, $this->sid);
            $data["data"] = $this->processAudits($audits, $which);
        }else {
            $systems = $this->functions->getSystems();
            $data['data'] = array();
            foreach ($systems as $sid => $name) {
                $filter = array(
                    'start_time' => $startDate,
                    'end_time' => $endDate
                );

                $audits = $this->BP->get_audit_history($filter, $sid);
                $data["data"] = array_merge($data['data'], $this->processAudits($audits, $which));
            }
        }
            return $data;
        }

        function processAudits($audits, $which)
        {
            $data = array();
            foreach ($audits as $audit) {
                if (is_numeric($which) and $which > 0 and $audit['notification_id'] != $which) {
                    continue;
                }
                if (is_string($which) and $which != $audit['username']) {
                    if ($which == "history") {
                        $user = $audit['username'];
                        $skip = strpos($user, "bypass") !== false;
                        if ($skip) {
                            continue;
                        }
                    } else {
                        continue;
                    }
                }
                if ($which) {
                    $data[] = $audit;
                }
            }
            return $data;
        }
    }
?>
