<?php

class Authenticate
{
    private $BP;
     
    public function __construct($BP)
    {
		$this->BP = $BP;
        $this->now = time();
    }
 
    public function login($data) {


        $localID = $this->BP->get_local_system_id();
        $systemInfo = $this->BP->get_system_info($localID);
        $sysName = $systemInfo['name'];
        $sid = $systemInfo['id'];

        $username = isset($data['username']) ? $data['username'] : null;
        $password = isset($data['password']) ? $data['password'] : null;

        $authCookie = $this->BP->authenticate($username, $password);

        if ($authCookie !== false){
            $result = $this->BP->set_cookie($authCookie, true);
            if ($result!== false) {
                $login = $this->buildOutput($authCookie);
            } else {
                $login = false;
            }
        } else {
            $login = false;
        }


        return $login;
        }

    function buildOutput($authCookie) {

        $userInfo = $this->BP->getUser();

        if ($userInfo !== false) {
            $id = isset($userInfo['id']) ? $userInfo['id'] : null;
            $adUser = isset($userInfo['ad_user']) ? $userInfo['ad_user'] : false;
            $superUser = isset($userInfo['superuser']) ? $userInfo['superuser'] : false;
            $administrator = isset($userInfo['administrator']) ? $userInfo['administrator'] : false;
            $target = isset($userInfo['target']) ? $userInfo['target'] : false;

            $data = array(
                'id' => $id,
                'superuser' => $superUser,
                'administrator' => $administrator,
                'ad_user' => $adUser,
                'target' => $target,
                'auth_token' => $authCookie
            );
        } else {
            $data = false;
        }

        return $data;
    }

public function logout($data){
    $cookie = isset($data['cookie']) ? $data['cookie'] : null;
    $result = $this->BP->logout($cookie);
    if ($result !== false){
        $result = $this->BP->destroy_cookie();
    }

    return $result;
}

} // end Summary

?>
