<?php
/**
 * Class to hold constants
 * User: Andrew Strasburger
 * Date: 8/19/14
 */

// in progress
class Constants {

    public function _construct()
    {
    }


    //-----Application Constants-----

    // Application Type Names
    // Defined by the Core - taken from: psql -Upostgres bpdb -c "select * from bp.application_lookup order by app_id"
    const APPLICATION_TYPE_NAME_FILE_LEVEL          = 'file-level';
    const APPLICATION_TYPE_NAME_EXCHANGE            = 'Exchange';
    const APPLICATION_TYPE_NAME_SQL_SERVER          = 'SQL Server';
    const APPLICATION_TYPE_NAME_ARCHIVE             = 'Archive';
    const APPLICATION_TYPE_NAME_VMWARE              = 'VMware';
    const APPLICATION_TYPE_NAME_HYPER_V             = 'Hyper-V';
    const APPLICATION_TYPE_NAME_SYSTEM_METADATA     = 'System Metadata';
    const APPLICATION_TYPE_NAME_ORACLE              = 'Oracle';
    const APPLICATION_TYPE_NAME_SHAREPOINT          = 'SharePoint';
    const APPLICATION_TYPE_NAME_UCS_SERVICE_PROFILE = 'UCS Service Profile'; //Cisco UCS
    const APPLICATION_TYPE_NAME_VOLUME              = 'Volume';  //NDMP

    // Application IDs (app_id)
    // Defined by the Core - taken from: psql -Upostgres bpdb -c "select * from bp.application_lookup order by app_id"
    const APPLICATION_ID_FILE_LEVEL             = 1;
    const APPLICATION_ID_EXCHANGE_2003          = 2;
    const APPLICATION_ID_EXCHANGE_2007          = 3;
    const APPLICATION_ID_EXCHANGE_2010          = 4;
    const APPLICATION_ID_EXCHANGE_2013          = 5;
    const APPLICATION_ID_SQL_SERVER_2005        = 21;
    const APPLICATION_ID_SQL_SERVER_2008        = 22;
    const APPLICATION_ID_SQL_SERVER_2008_R2     = 23;
    const APPLICATION_ID_SQL_SERVER_2012        = 24;
    const APPLICATION_ID_ARCHIVE                = 30;
    const APPLICATION_ID_VMWARE                 = 40;
    const APPLICATION_ID_HYPER_V_2008_R2        = 50;
    const APPLICATION_ID_HYPER_V_2012           = 51;
    const APPLICATION_ID_SYSTEM_METADATA        = 60;
    const APPLICATION_ID_ORACLE_11              = 100;  // Not Applicable in our Environment
    const APPLICATION_ID_ORACLE_12              = 101;
    const APPLICATION_ID_SHAREPOINT_2007        = 110;
    const APPLICATION_ID_SHAREPOINT_2010        = 111;
    const APPLICATION_ID_SHAREPOINT_2013        = 112;
    const APPLICATION_ID_UCS_SERVICE_PROFILE    = 120; //Cisco UCS Service Profile
    const APPLICATION_ID_VOLUME                 = 130;  //NDMP

    // Application Names
    // Defined by the Core - taken from: psql -Upostgres bpdb -c "select * from bp.application_lookup order by app_id"
    const APPLICATION_NAME_FILE_LEVEL           = 'file-level';
    const APPLICATION_NAME_EXCHANGE_2003        = 'Exchange 2003';
    const APPLICATION_NAME_EXCHANGE_2007        = 'Exchange 2007';
    const APPLICATION_NAME_EXCHANGE_2010        = 'Exchange 2010';
    const APPLICATION_NAME_EXCHANGE_2013        = 'Exchange 2013';
    const APPLICATION_NAME_SQL_SERVER_2005      = 'SQL Server 2005';
    const APPLICATION_NAME_SQL_SERVER_2008      = 'SQL Server 2008';
    const APPLICATION_NAME_SQL_SERVER_2008_R2   = 'SQL Server 2008 R2';
    const APPLICATION_NAME_SQL_SERVER_2012      = 'SQL Server 2012';
    const APPLICATION_NAME_ARCHIVE              = 'Archive';
    const APPLICATION_NAME_VMWARE               = 'VMware';
    const APPLICATION_NAME_HYPER_V_2008_R2      = 'Hyper-V 2008 R2';
    const APPLICATION_NAME_HYPER_V_2012         = 'Hyper-V 2012';
    const APPLICATION_NAME_SYSTEM_METADATA      = 'System Metadata';
    const APPLICATION_NAME_ORACLE_11            = 'Oracle 11';  // Not Applicable in our Environment
    const APPLICATION_NAME_ORACLE_12            = 'Oracle 12';
    const APPLICATION_NAME_SHAREPOINT_2007      = 'SharePoint 2007';
    const APPLICATION_NAME_SHAREPOINT_2010      = 'SharePoint 2010';
    const APPLICATION_NAME_SHAREPOINT_2013      = 'SharePoint 2013';
    const APPLICATION_NAME_UCS_SERVICE_PROFILE  = 'UCS Service Profile'; //Cisco UCS
    const APPLICATION_NAME_VOLUME               = 'Volume';  //NDMP

    //-----Archive Constants-----

    // Archive Statuses
    const ARCHIVE_STATUS_ARCHIVE_FAILED =       'archive failed';
    const ARCHIVE_STATUS_ARCHIVE_IN_PROGRESS =  'archive in progress';
    const ARCHIVE_STATUS_ARCHIVE_SUCCESS =      'archive success';
    const ARCHIVE_STATUS_IMPORT_FAILED =        'import failed';
    const ARCHIVE_STATUS_IMPORT_IN_PROGRESS =   'import in progress';
    const ARCHIVE_STATUS_IMPORT_SUCCESS =       'import success';

    //-----Backup Constants-----

    // Regular Backup Types
    const BACKUP_TYPE_MASTER                    = 'master';
    const BACKUP_TYPE_DIFFERENTIAL              = 'differential';
    const BACKUP_TYPE_INCREMENTAL               = 'incremental';
    const BACKUP_TYPE_BAREMETAL                 = 'baremetal';
    const BACKUP_TYPE_SELECTIVE                 = 'selective';
    const BACKUP_TYPE_MSSQL_FULL                = 'mssql full';
    const BACKUP_TYPE_MSSQL_DIFFERENTIAL        = 'mssql differential';
    const BACKUP_TYPE_MSSQL_TRANSACTION         = 'mssql transaction';
    const BACKUP_TYPE_EXCHANGE_FULL             = 'exchange full';
    const BACKUP_TYPE_EXCHANGE_DIFFERENTIAL     = 'exchange differential';
    const BACKUP_TYPE_EXCHANGE_INCREMENTAL      = 'exchange incremental';
    const BACKUP_TYPE_LEGACY_MSSQL_FULL         = 'legacy mssql full';
    const BACKUP_TYPE_LEGACY_MSSQL_DIFF         = 'legacy mssql diff';
    const BACKUP_TYPE_LEGACY_MSSQL_TRANS        = 'legacy mssql trans';
    const BACKUP_TYPE_VMWARE_FULL               = 'vmware full';
    const BACKUP_TYPE_VMWARE_DIFFERENTIAL       = 'vmware differential';
    const BACKUP_TYPE_VMWARE_INCREMENTAL        = 'vmware incremental';
    const BACKUP_TYPE_HYPER_V_FULL              = 'hyperv full';
    const BACKUP_TYPE_HYPER_V_INCREMENTAL       = 'hyperv incremental';
    const BACKUP_TYPE_HYPER_V_DIFFERENTIAL      = 'hyperv differential';
    const BACKUP_TYPE_HYPER_V_FULL_ALT          = 'hyper-v full';
    const BACKUP_TYPE_HYPER_V_INCREMENTAL_ALT   = 'hyper-v incremental';
    const BACKUP_TYPE_HYPER_V_DIFFERENTIAL_ALT  = 'hyper-v differential';
    const BACKUP_TYPE_ORACLE_FULL               = 'oracle full';
    const BACKUP_TYPE_ORACLE_INCR               = 'oracle incr';
    const BACKUP_TYPE_SHAREPOINT_FULL           = 'sharepoint full';
    const BACKUP_TYPE_SHAREPOINT_DIFF           = 'sharepoint diff';
    const BACKUP_TYPE_SYSTEM_METADATA           = 'system metadata';
    const BACKUP_TYPE_UCS_SERVICE_PROFILE_FULL  = 'ucs service profile full';
    const BACKUP_TYPE_NDMP_FULL                 = 'ndmp full';
    const BACKUP_TYPE_NDMP_DIFF                 = 'ndmp diff';
    const BACKUP_TYPE_NDMP_INCR                 = 'ndmp incr';

    // Extra Backup Types
    const BACKUP_TYPE_RESTORE                   = 'restore';
    const BACKUP_TYPE_VIRTUAL_RESTORE           = 'virtual restore';
    const BACKUP_TYPE_INTEGRATED_BM_RESTORE     = 'integrated bm restore';
    const BACKUP_TYPE_VERIFY                    = 'verify';

    // Securesync Backup Types (Replication and Vaulting)
    const BACKUP_TYPE_SECURESYNC_MASTER                    = 'securesync master';
    const BACKUP_TYPE_SECURESYNC_DIFFERENTIAL              = 'securesync differential';
    const BACKUP_TYPE_SECURESYNC_INCREMENTAL               = 'securesync incremental';
    const BACKUP_TYPE_SECURESYNC_BAREMETAL                 = 'securesync baremetal';
    const BACKUP_TYPE_SECURESYNC_DPU_STATE                 = 'securesync dpustate';
    const BACKUP_TYPE_SECURESYNC_LOCAL_DIRECTORY           = 'securesync localdir';
    const BACKUP_TYPE_SECURESYNC_MS_SQL                    = 'securesync SQL';   // (legacy securesync: includes full, differential, transaction logs)
    const BACKUP_TYPE_SECURESYNC_EXCHANGE                  = 'securesync exchange';  //Securesync Exchange Server backup (legacy - no type available)
    const BACKUP_TYPE_SECURESYNC_MSSQL_FULL                = 'securesync mssql full';
    const BACKUP_TYPE_SECURESYNC_MSSQL_DIFFERENTIAL        = 'securesync mssql diff';
    const BACKUP_TYPE_SECURESYNC_MSSQL_TRANSACTION         = 'securesync mssql trans';
    const BACKUP_TYPE_SECURESYNC_EXCHANGE_FULL             = 'securesync msexch full';
    const BACKUP_TYPE_SECURESYNC_EXCHANGE_DIFFERENTIAL     = 'securesync msexch diff';
    const BACKUP_TYPE_SECURESYNC_EXCHANGE_INCREMENTAL      = 'securesync msexch incr';
    const BACKUP_TYPE_SECURESYNC_VMWARE_FULL               = 'securesync vmware full';
    const BACKUP_TYPE_SECURESYNC_VMWARE_DIFFERENTIAL       = 'securesync vmware diff';
    const BACKUP_TYPE_SECURESYNC_VMWARE_INCREMENTAL        = 'securesync vmware incr';
    const BACKUP_TYPE_SECURESYNC_HYPER_V_FULL              = 'securesync hyperv full';
    const BACKUP_TYPE_SECURESYNC_HYPER_V_INCREMENTAL       = 'securesync hyperv incr';
    const BACKUP_TYPE_SECURESYNC_HYPER_V_DIFFERENTIAL      = 'securesync hyperv diff';
    const BACKUP_TYPE_SECURESYNC_ORACLE_FULL               = 'securesync oracle full';
    const BACKUP_TYPE_SECURESYNC_ORACLE_INCR               = 'securesync oracle incr';
    const BACKUP_TYPE_SECURESYNC_SHAREPOINT_FULL           = 'securesync sharepoint full';
    const BACKUP_TYPE_SECURESYNC_SHAREPOINT_DIFF           = 'securesync sharepoint diff';
    const BACKUP_TYPE_SECURESYNC_SYSTEM_METADATA           = 'securesync system metadata';
    const BACKUP_TYPE_SECURESYNC_UCS_SERVICE_PROFILE_FULL  = 'securesync ucs service profile full';
    const BACKUP_TYPE_SECURESYNC_NDMP_FULL                 = 'securesync ndmp full';
    const BACKUP_TYPE_SECURESYNC_NDMP_DIFF                 = 'securesync ndmp diff';
    const BACKUP_TYPE_SECURESYNC_NDMP_INCR                 = 'securesync ndmp incr';

    // Backup Display Types
    // Reports::get_backup_type_display_name will map backup types to a backup display type
    const BACKUP_DISPLAY_TYPE_FULL          = 'Full';
    const BACKUP_DISPLAY_TYPE_DIFFERENTIAL  = 'Differential';
    const BACKUP_DISPLAY_TYPE_INCREMENTAL   = 'Incremental';
    const BACKUP_DISPLAY_TYPE_BAREMETAL     = 'Bare Metal';
    const BACKUP_DISPLAY_TYPE_SELECTIVE     = 'Selective';
    const BACKUP_DISPLAY_TYPE_TRANSACTION   = 'Transaction';
    const BACKUP_DISPLAY_TYPE_RESTORE       = 'Restore';

    // Backup Statuses (status)
    const BACKUP_STATUS_SUCCESS     = 0;
    const BACKUP_STATUS_WARNINGS    = 1;
    const BACKUP_STATUS_FAILURE     = 2;

    //-----Client Constants-----

    // Asset Type
    const ASSET_TYPE_ESX            = 'esx';
    const ASSET_TYPE_HYPER_V_VM     = 'Hyper-V:VM';
    const ASSET_TYPE_PHYSICAL       = 'physical';
    const ASSET_TYPE_V_CENTER       = 'vCenter';
    const ASSET_TYPE_VMWARE_WM      = 'VMware:VM';
    const ASSET_TYPE_VMWARE_HOST    = 'VMware Host';

    // Client Names vCenter-RRC
    const CLIENT_NAME_VCENTER_RRC   = "vCenter-RRC";

    // Operating System Type (os type)
    const OS_DOS            = 1;
    const OS_WIN_16         = 2;
    const OS_NT             = 3;
    const OS_WINDOWS_95     = 4;
    const OS_OS_2           = 5;
    const OS_NOVELL         = 6;
    const OS_UNIX3          = 7;
    const OS_ODT            = 8;
    const OS_OS5            = 9;
    const OS_UNIX4          = 10;
    const OS_SOLARIS        = 11;
    const OS_SUN_OS         = 12;
    const OS_NOVELL_4       = 13;
    const OS_OSF1           = 14;
    const OS_NT_SERVER      = 15;
    const OS_AIX            = 16;  // Not Applicable in our Environment
    const OS_SGI            = 17;
    const OS_DGUX           = 18;
    const OS_HP_UX          = 19;
    const OS_LINUX          = 20;
    const OS_BSDI           = 21;
    const OS_USL            = 22;
    const OS_UNIXWARE       = 23;
    const OS_FREEBSD        = 24;
    const OS_MACOS          = 25;
    const OS_NOVELL_5       = 26;  // The API Guide lists this as just Novell, but there is already one Novell, so I am guessing this is Novell 5
    const OS_Novell_6       = 27;
    const OS_NOVELL_65      = 28;
    const OS_WINDOWS_2000   = 29;
    const OS_WINDOWS_XP     = 30;
    const OS_WINDOWS_2003   = 31;
    const OS_WINDOWS_VISTA  = 32;
    const OS_IBMI5          = 33;
    const OS_OES            = 34;
    const OS_WINDOWS_2008   = 35;
    const OS_WIN_2008_R2    = 36;
    const OS_WINDOWS_7      = 37;
    const OS_WINDOWS_8      = 38;
    const OS_WINDOWS_2012   = 39;
    const OS_GENERIC        = 40;
    const OS_WINDOWS_8_1    = 41;
    const OS_WINDOWS_2012_R2= 42;

    //-----Inventory Constants-----

    // Hypervisor Type (hv type)
    const HV_UNKNOWN    = 0;
    const HV_WINDOWS    = 1;
    const HV_HYPER_V    = 2;
    const HV_VMWARE     = 3;

    // Node Type
    const NODE_TYPE_NONE                = 0;
    const NODE_TYPE_DISK                = 1;
    const NODE_TYPE_VM                  = 2;
    const NODE_TYPE_FOLDER              = 3;
    const NODE_TYPE_RESOURCE_POOL       = 4;
    const NODE_TYPE_HOST                = 5;
    const NODE_TYPE_DATACENTER          = 6;
    const NODE_TYPE_ENVIRONMENT         = 7;
    const NODE_TYPE_UNIVERSE            = 8;
    const NODE_TYPE_CLUSTER             = 9;
    const NODE_TYPE_VM_TEMPLATE_FOLDER  = 10;
    const NODE_TYPE_TAG                 = 11;
    const NODE_TYPE_TEMPLATE            = 12;
    const NODE_TYPE_VAPP                = 13;
    const NODE_TYPE_ROOT_FOLDER         = 14;
    const NODE_TYPE_ROOT_TAG            = 15;
    const NODE_TYPE_XEN                 = 16;  // Not Applicable in our Environment
    const NODE_TYPE_COMPUTER            = 17;
    const NODE_TYPE_VAPP_ROOT           = 18;
    const NODE_TYPE_CDROM               = 19;
    const NODE_TYPE_VM_NIC              = 20;
    const NODE_TYPE_USB                 = 21;
    const NODE_TYPE_SNAPSHOT            = 22;
    const NODE_TYPE_DATASTORE           = 23;
    const NODE_TYPE_JOB                 = 24;
    const NODE_TYPE_DISCOVERED_VM       = 25;
    const NODE_TYPE_GENERIC             = 99;

    //-----Report Constants-----

    // Date and Time Formats
    const DATE_FORMAT_DATE_THEN_12HR_TIME   = "M j, Y g:i a";
    const DATE_FORMAT_HRS_MINS_SECS         = "H:i:s";
    const DATE_FORMAT_US                    = "m/d/Y";
    const DATE_TIME_FORMAT_US               = "m/d/Y h:i:s a";
    const TIME_FORMAT_12H                   = "h:i:s a";
    const DATE_ONE_WEEK_AGO                 = "today -6 days";

    // Statuses
    const STATUS_COMPLETED =            'Completed';
    const STATUS_FAILURE =              'Failure';
    const STATUS_IN_PROGRESS =          'In Progress';
    const STATUS_ARCHIVE_IN_PROGRESS =  'Archive In Progress';
    const STATUS_IMPORT_IN_PROGRESS =   'Import In Progress';
    const STATUS_NEEDED =               'Needed';
    const STATUS_NOT_APPLICABLE =       'N/A';
    const STATUS_RUNNING =              'Running';
    const STATUS_SUCCESS =              'Success';
    const STATUS_WAITING =              'Waiting';
    const STATUS_WARNING =              'Warning';

    //-----Retention Constants-----

    // Retention Type
    const RETENTION_NONE        = 0;
    const RETENTION_TYPICAL     = 1;
    const RETENTION_CUSTOM      = 2;
    const RETENTION_LEGAL_HOLD  = 3;

    //-----Storage Constants-----

    // Storage Type IDs
    const STORAGE_TYPE_ID_INTERNAL_DAS_NOT_MODIFIABLE   = 0;
    const STORAGE_TYPE_ID_ISCI_SAN                      = 1;
    const STORAGE_TYPE_ID_FC_SAN                        = 2;
    const STORAGE_TYPE_ID_AOE_SAN                       = 3;
    const STORAGE_TYPE_ID_NAS                           = 4;
    const STORAGE_TYPE_ID_ADDED_INTERNAL_DAS_MODIFIABLE = 5;

    // Storage Type Names
    const STORAGE_TYPE_NAME_INTERNAL_DAS_NOT_MODIFIABLE     = 'internal';
    const STORAGE_TYPE_NAME_ISCI_SAN                        = 'iscsi';
    const STORAGE_TYPE_NAME_FC_SAN                          = 'fc';
    const STORAGE_TYPE_NAME_AOE_SAN                         = 'aoe';
    const STORAGE_TYPE_NAME_NAS                             = 'nas';
    const STORAGE_TYPE_NAME_ADDED_INTERNAL_DAS_MODIFIABLE   = 'added_disks';

    // Storage Type Display Names
    const STORAGE_TYPE_DISPLAY_NAME_INTERNAL_DAS_NOT_MODIFIABLE     = 'Internal';
    const STORAGE_TYPE_DISPLAY_NAME_ISCI_SAN                       = 'iSCSI';
    const STORAGE_TYPE_DISPLAY_NAME_FC_SAN                         = 'FC';
    const STORAGE_TYPE_DISPLAY_NAME_AOE_SAN                        = 'AOE';
    const STORAGE_TYPE_DISPLAY_NAME_NAS                            = 'NAS';
    const STORAGE_TYPE_DISPLAY_NAME_ADDED_INTERNAL_DAS_MODIFIABLE  = 'Direct-Attached Disk';

    // Storage Usage
    const STORAGE_USAGE_ARCHIVE = 'archive';
    const STORAGE_USAGE_BACKUP  = 'backup';
    const STORAGE_USAGE_SOURCE  = 'source';
    const STORAGE_USAGE_VAULT   = 'vault';

} 