<?php

$dir = '/api/includes/';

class Notifications
{
    private $BP;

    public function __construct($BP)
    {
        $this->BP = $BP;

    }

    public function get_alerts($which, $filter, $sid)
    {
        require_once('alerts.php');
        $alerts = new Alerts($this->BP, $sid);
        return $alerts->get($which, $filter, $sid);
    }

    public function get_audit_history($which, $sid)
    {
        require_once('audit-history.php');
        $audit = new AuditHistory($this->BP, $sid);
        return $audit->get($which);
    }

    public function get_snmp_config($which)
    {
        require_once('snmp-config.php');
        $snmpConfig = new SNMPConfig($this->BP);
        return $snmpConfig->get($which);
    }

    public function get_snmp_history($which)
    {
        require_once('snmp-config.php');
        $snmpConfig = new SNMPConfig($this->BP);
        return $snmpConfig->get($which);
    }

    public function get_jobs($which, $filter, $sid, $systems)
    {
        require_once('jobs.php');
        $jobs = new Jobs($this->BP, $sid);
        return $jobs->get($which, $filter, $sid, $systems);
    }

    public function get_psa_info($which)
    {
        require_once('psa.php');
        $info = new PSA($this->BP);
        return $info->get($which);
    }

    public function delete_job($which, $sid){
        require_once('jobs.php');
        $jobs = new Jobs($this->BP, $sid);
        return $jobs->delete($which);
    }

    public function suspend_resume($action, $which, $sid){
        require_once('jobs.php');
        $jobs = new Jobs($this->BP, $sid);
        return $jobs->suspend_resume($action, $which);
    }

    public function close_alert($which, $sid){
        require_once('alerts.php');
        $alerts = new Alerts($this->BP, $sid);
        return $alerts->close($which, $sid);
    }
}

?>
