<?php
 // defines BP, xml, action, cookie
require 'header.php';
require 'userfunctions.php';

// The maximum number of files in a single directory to retrieve at once.
define("MAX_FILES", 1000);
// The maximum number of items (files, dirs) to return at once.
define("MAX_ITEMS", 5000);

$systemName = isset($_GET['sname']) ? $_GET['sname'] : "unknown";
$backupID = isset($_GET['bid']) ? (int)$_GET['bid'] : 0;
$dpuID = getSystemIDfromName($BP, $systemName);

// figure out which sysID to used based on view.
$localID = $BP->get_local_system_id();
$sysID = $grandClientView ? $localID : $dpuID;

//
// How many items to skip, and the maximum number to return.
//
$skip = isset($_GET['skip']) ? (int)$_GET['skip'] : 0;
$maxItems = isset($_GET['max']) ? (int)$_GET['max'] + $skip : MAX_ITEMS + $skip;
$itemCount = 0;

// see if we are downloading entire file to server.
$bSaveAll = ($skip == 0 && $maxItems <= 0);
// see if we are writing to a file directly or return via XML.
$bToDisk = ($maxItems == -1);

//
// Initialize the last file in the directory to an empty string (no last file).  This is used
// there are so many entries in a directory that they can only be partially loaded at one time.
//
$lastFile = "";

//
// Start at the top level, getting volumes, so name, id, startDir are all blank strings.
//
$volumes = $BP->get_backup_files($backupID, "", "", $lastFile, MAX_FILES, $sysID);
if ($volumes !== false) {
	$xml->push('root');
	foreach ($volumes as $volume) {
		if ($volume['date'] == 0) {
			; // Skip it, it is a shell only.
		} else {
			if ($bSaveAll || $itemCount >= $skip) {
				// It is a volume.
				$file = $volume['name'];
				$xml->push('File');	
				// For Linux files, remove the volume placeholder.	
				$xml->element('Name', str_replace(LINUX_VOLUME, "", $file));
				$xml->element('Size', number_format($volume['size'], 1));
				$xml->pop();
			}
			$itemCount++;
		}
		 getFiles($BP, $xml, $backupID, $volume['name'], $volume['id'], $itemCount, $lastFile, $sysID);
	}
	$xml->pop(); //root
}

if ($bToDisk) {
	// write to a file....
} else {
	echo($xml->getXml());
}

     
//
// Get files based on id.  If a directory, recursively get files.
// Skip "skip" files before outputting data.
// Stop at "maxItems".
//
function getFiles($BP, $xml, $bid, $name, $id, &$items, &$lastFile, $sysID) {  
	global $maxItems;
	global $skip;
	global $bSaveAll;
	
	$dirs = $BP->get_backup_files($bid, $name, $id, $lastFile, MAX_FILES, $sysID);
	$bDone = false;
	while (!$bDone) {
		$dir = "";
		if ($dirs !== false) {
			foreach ($dirs as $dir) {
				if (!$bSaveAll && $items >= $maxItems) {
					$xml->element('More', 1);
					$bDone = true;
					break;
				} else {
					$file = $name . '/' . $dir['name'];
					if ($dir['type'] == 'directory' && $dir['date'] == 0) {
						; // Skip it, it is a shell only.
					} else {
						if ($bSaveAll || $items >= $skip) {
							$xml->push('File');	
							// For Linux files, remove the volume placeholder.	
							$xml->element('Name', str_replace(LINUX_VOLUME, "", $file));
							$xml->element('Size', number_format($dir['size'], 1));
							$xml->pop();
						}
						$items++;
					}
					if ($dir['type'] == 'directory') {
						// Recursively call function with the directory.
						getFiles($BP, $xml, $bid, $file, $dir['id'], $items, $lastFile, $sysID);
					}
				}
			}
			//
			// See if there are more items in this subdirectory by checking count of items returned.
			// If there are more, call the API again, specifying the lastFile as the last one in the prior return array.
			// Otherwise, set done to true and exit the loop.
			//
			if (MAX_FILES == 0 || count($dirs) < MAX_FILES) {
				$bDone = true;
				$lastFile = "";
			} else if (!$bDone) {
				$lastFile = $dir['name'];
				$dirs = $BP->get_backup_files($bid, $name, $dir['id'], $lastFile, MAX_FILES, $sysID);
				if ($dirs === false) {
					$bDone = true;
					break;
				}
			}
		} else {
			$bDone = true;
		}
	}
}

$BP->destroyCookie();
?>

