<?php



if (php_sapi_name() === 'cli') {
	$options = getopt("a::ld::ldl::");

	// Include standard definitions/common functions.
	require 'defines.php';
	// Include the bpl.so API's. Defines must be included before this.
	require 'bp.php';
	// Include XML function
	require 'xmlwriter.php';
	// Include logging functions
	require 'logger.php';

	$authentication_cookie = "1:";

	$logDirectory = isset($options['ld']) ? $options['ld'] : LOG_DIRECTORY;
	$logLevel = isset($options['lvl']) ? $options['lvl'] : "0";

	$action = isset($options['a']) ? $options['a'] : "list";


	$Log = new Logger($logLevel, $logDirectory);
	$xml = new ria_xmlWriter(false);
	$BP = new BP($authentication_cookie);

	$BP->bypass_cookie(1);
} else {
	require 'header.php';

	// Get authentication cookie.
	$authentication_cookie = isset($_REQUEST['auth']) ? $_REQUEST['auth'] : "";
	$logLevel = isset($_GET['lvl']) ? $_GET['lvl'] : "5";

	// The action is the operation the user is taking.
	$action = isset($_REQUEST['type']) ? $_REQUEST['type'] : "list";
}

switch( $action ) {

	case "list":
		$nvpList = $BP->get_nvp_list( NVP_TYPE, NVP_NAME );
		//$Log->writeVariable( $nvpList );
		$cached = isset( $nvpList[ NVP_CACHE_DATA ] ) ? $nvpList[ NVP_CACHE_DATA ] : NULL;

		if ( $cached ) {
			$closeRootIndex = strpos( $cached, "</root>");
			$date = isset( $nvpList[ NVP_CACHE_DATE ] ) ? $nvpList[ NVP_CACHE_DATE ] : NULL;
			$time = isset( $nvpList[ NVP_CACHE_TIME ] ) ? $nvpList[ NVP_CACHE_TIME ] : NULL;
			if ( $date && $time ) {
				$lastCached = "\t<LastCache date=\"$date\" time=\"$time\">\n";
			}

			$cached = substr_replace($cached, $lastCached, $closeRootIndex, 0);
		}
		header("Content-type: text/xml");
		echo( $cached );
		break;
	case "update":
		$Log->writeVariable("buildTree called ");

		$buildTreeInfo  = curl_init("localhost/recoveryconsole/bpl/buildtree.php?days=7&auth=1:&lvl=$logLevel");

		$options = array
		(
		    CURLOPT_HEADER=>false,
		    CURLOPT_RETURNTRANSFER=>true,
		    CURLOPT_FOLLOWLOCATION=>true
		);
		curl_setopt_array($buildTreeInfo,$options);
		$buildTree_output = curl_exec($buildTreeInfo);
		curl_close($buildTreeInfo);

		$Log->writeVariable("Curl exec buildTree called ");

		$Log->writeVariable("START XML for buildTree ");
		$Log->writeVariable( $buildTree_output  );
		$Log->writeVariable("END XML for buildTree ");


		$nvpList = array();
		$nvpList[ NVP_CACHE_DATA ] = $buildTree_output;
		$nvpList[ NVP_CACHE_DATE ] = date('m/d/Y');
		$nvpList[ NVP_CACHE_TIME ] = date(TIME_FORMAT_12HR);

		$Log->writeVariable("START XML for buildTree ");

		$BP->buildResult($xml, $BP->save_nvp_list( NVP_TYPE, NVP_NAME, $nvpList ) );

		$Log->writeVariable("Retrieving from cache");
		header("Content-type: text/xml");
		echo($xml->getXml());
		break;
}

$BP->destroyCookie();
?>