<?php
// defines BP, xml, action, cookie
require 'header.php';

switch ($action) {				
	case "list":	// list all the current commands.	
					$systemID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
					if (!isset($_GET['sid']) || $systemID == $BP->get_local_system_id()) {
						$commandList = $BP->get_command_list();
					} else {
						$commandList = $BP->get_command_list($systemID);
					}
					if ($commandList == false) {
						$BP->buildResult($xml, false);
					} else {
						$xml->push('root');	
						displayCommandList($xml, $BP, $commandList, $systemID);
						$xml->pop();
					}
					echo($xml->getXml());
					break;
					
	case "run":	// Run specific command specified by its name.
					if (isset($_GET['name'])) {
						$commandName = $_GET['name'];				
						$systemID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
						if (!isset($_GET['sid']) || $systemID == $BP->get_local_system_id()) {
							$commandOutput = $BP->run_command($commandName, "");
						} else {
							$commandOutput = $BP->run_command($commandName, "", $systemID);
						}
						if ($commandOutput === false) {
							$BP->buildResult($xml, false);
						} else {
							$xml->push('root');
							$xml->push("Command", array("Name" => $commandName));
							$xml->push("Output");
							$xml->cData($commandOutput);
							$xml->pop(); // Output
							$xml->pop(); // Command
							$xml->pop();
						}
						echo($xml->getXml());
					} else {
						$BP->buildResult($xml, false,
							"commands: improper argument format; a name should be specified to execute a command.");
						echo($xml->getXml());
					}
					break;	
}

function displayCommandList($xml, $BP, $commandList, $systemID)
{
	foreach ($commandList as $commandName) {
		$commandInfo = $BP->get_command_info($commandName, $systemID);
		if ($commandInfo === false) {
			// place a blank named command so the CMC can warn the user and continue.
			$commandInfo = array('name' => $commandName, 'description' => "Warning:  Unable to retrieve command description.");
		}
		displayCommandInfo($xml, $BP, $commandInfo, $systemID);
	}
}

function displayCommandInfo($xml, $BP, $commandInfo, $systemID)
{
	$xml->push("Command", array("Name" => $commandInfo['name']));
	if (array_key_exists('action', $commandInfo))
		$xml->element('Action', $commandInfo['action']);
	if (array_key_exists('description', $commandInfo))
		$xml->element('Description', $commandInfo['description']);
	$xml->pop(); // command
}

$BP->destroyCookie();
?>
