<?php
// defines BP, xml, action, cookie
require 'header.php';

require 'credentials.php';

// set DPU id
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
// get password via POST, not URL
$crid = isset($_GET['crid']) ? (int)$_GET['crid'] : -1;
getCredentials($BP, $dpuID, $crid, $username, $password, $domain, $is_default, $use_default, $display_name);
$Credentials = new Credentials();

$appID    = isset($_GET['aid'])  ? (int)$_GET['aid']  : -1;
$clientID = isset($_GET['clid']) ? (int)$_GET['clid'] : -1;

switch ($action) {
	
	case "default":
			$Credentials->getDefault($BP, $xml, $dpuID, true);
			echo($xml->getXml());
			break;

	case "delete":
			$crid = isset($_GET['crid']) ? (int)$_GET['crid'] : -1;
			$Credentials->delete($BP, $xml, $crid, $dpuID, true);
			echo($xml->getXml());
			break;
			
	// returns a list of unique credentials with their client, application, and instance associations
	case "list":
			$Credentials->getList($BP, $xml, $dpuID, true);
			echo($xml->getXml());
			break;
			
	// returns a list of named credentials
	case "namedcredentials":
			$Credentials->getNamedCredentials($BP, $xml, $dpuID, true);
			echo($xml->getXml());
			break;
	
	// binds a client app to a credential - 
	case "bind_client_app_credential":
		$result = $BP->save_client_app_credentials( $clientID, $appID, $crid, $dpuID );
		$BP->buildResult($xml, $result);
		echo($xml->getXml());
		break;
		
	// removed credential binding from a client app
	case "unbind_client_app_credential":
		$result = $BP->delete_client_app_credentials( $clientID, $appID, $dpuID );
		$BP->buildResult($xml, $result);
		echo($xml->getXml());
		break;
	
	// gets credential associated with client App
	case "get_client_app_credential":
		$result = $BP->get_client_app_credentials( $clientID, $appID, $dpuID );
		if ( $result !== false ) {
			$Credentials->buildXML( $xml, $result, '' );
		} else {
			$BP->buildResult($xml, $result);
		}
		echo($xml->getXml());
		break;

	case "save":
			$result = $Credentials->save($BP, $dpuID, $crid, $username, $password, $domain, $is_default, $display_name);
			if ($result !== false) {
				$xml->push('root');
				if ($result === true) {
					// Existing entry, no ID returned.
					$Credentials->buildXML($xml, array(	'credential_id' => $crid,
														'username' => $username,
														'domain' => $domain,
														'is_default' => $is_default,
														'display_name' => $display_name), 'Credential');
				} else {
					// new entry, ID returned.
					$Credentials->buildXML($xml, array(	'credential_id' => $result,
														'username' => $username,
														'domain' => $domain,
														'is_default' => $is_default,
														'display_name' => $display_name), 'Credential');
				}
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, $result);
			}
			echo($xml->getXml());
			break;			
			
}


function getCredentials($BP, $dpuID, &$crid, &$username, &$password, &$domain, &$is_default, &$use_default, &$display_name) {
	$username = isset($_GET['username']) ? $_GET['username'] : "";
	$password = isset($_POST['password']) ? urldecode($_POST['password']) : "";
	$domain = isset($_GET['domain']) ? $_GET['domain'] : "";
	$display_name = isset($_GET['display_name']) ? $_GET['display_name'] : "";
	
	if (isset($_GET['is_default'])) {
		$is_default = $_GET['is_default'] == '1' ? true : false;
	} else {
		$is_default = false;
	}
	if (isset($_GET['use_default'])) {
		$use_default = $_GET['use_default'] == '1' ? true : false;
	} else {
		$use_default = false;
	}
	
	
	if ($use_default) {
		$credentials = $BP->get_default_credentials($dpuID);
		$crid = isset($credentials['credential_id']) ? $credentials['credential_id'] : -1;
		$username = isset($credentials['username']) ? $credentials['username'] : "";
		$domain = isset($credentials['domain']) ? $credentials['domain'] : "";
		//$password = isset($credentials['password']) ? $credentials['password'] : "";
		$is_default = isset($credentials['is_default']) ? $credentials['is_default'] : false;
		$display_name = isset($credentials['display_name']) ? $credentials['display_name'] : false;		
	}
}
?>