<?php
// defines BP, xml, action, cookie
require 'header.php';
require 'userfunctions.php';

$searchOptions = array();

switch ($action) {
		
	case "search":
		// starts a search files job.
		if (isset($_GET['id'])) {
			$id = (int)$_GET['id'];					
			$options = array ('name' => 'name');
			$bOptions = array('expression' => 'expr',
							  'case' => 'case',
							  'include' => 'include');		
			$searchOptions = buildOptions($searchOptions, $options, $bOptions);
			$iOptions = array('start_date' => 'start_date',
							  'end_date' => 'end_date');
			$searchOptions = addIntegerOptions($searchOptions, $iOptions);
			if (isset($_GET['start_size'])) {
				$startSize = (float)$_GET['start_size'];
				$searchOptions = array_merge($searchOptions, array ("start_size" => $startSize));
			}
			if (isset($_GET['end_size'])) {
				$endSize = (float)$_GET['end_size'];
				$searchOptions = array_merge($searchOptions, array ("end_size" => $endSize));
			}
			$systemID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$result = array();					
			if (!isset($_GET['sid']) || $systemID == $BP->get_local_system_id()) {
				$result = $BP->start_file_search($searchOptions, $id);
			} else {
				$result = $BP->start_file_search($searchOptions, $id, $systemID);
			}																
			if ($result === false) {
				$BP->buildResult($xml, false);
			} else {
				$xml->push('root');
				$xml->emptyElement('Search', array('ID' => $result['pid'],
												   'Time' => $result['timestr']));
				$xml->pop(); // root
			}
		} else {
			$BP->buildResult($xml, false, "a client id must be specified when searching backups.");
		}
		echo($xml->getXml());								
		break;
																					
	case "results":
		// returns a list files in the backups that meet the search criteria.
		if (isset($_GET['searchID']) && isset($_GET['time'])) {
			$searchID = (int)$_GET['searchID'];
			$timeString = $_GET['time'];
			if (isset($_GET['id'])) {
				$clientID = (int)$_GET['id'];
				$searchArray = array('pid' => $searchID, 'timestr' => $timeString);
				
				$systemID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();				
				if (!isset($_GET['sid']) || $systemID == $BP->get_local_system_id()) {
					$fileList = $BP->get_file_search_results($searchArray);
				} else {
					$fileList = $BP->get_file_search_results($searchArray, $systemID);
				}
				// lmc - test
				//$fileList = false;
				//$fileList = array();														
				if ($fileList === false) {
					$BP->buildResult($xml, false);
				} else if (is_scalar($fileList)) {
					$xml->push('root');
					$xml->emptyElement('SearchStatus', array('State' => $fileList));
					$xml->pop();
				} else if (count($fileList) == 0) {
					//$BP->buildResult($xml, false, "no files met the search criteria.");
					global $Log;
					$Log->writeError("No files met the search criteria.", false);
					$xml->push('root');
					$xml->emptyelement('BackupStatusArray');
					$xml->emptyelement('FilesFoundArray');
					$xml->pop();
				} else {
					$xml->push('root');
					displayBackupList($xml, $BP, $fileList, $clientID, $systemID);
					displaySearchList($xml, $BP, $fileList, $systemID);
					$xml->pop();
				}
			} else {
				$BP->buildResult($xml, false, "Error: a client id must be specified when retrieving search results.");
			}
		} else {
			$BP->buildResult($xml, false, "Error: a search id and time string must be specified when retrieving search results.");
		}
		echo($xml->getXml());								
		break;			

}

function displayBackupList($xml, $BP, $fileList, $clientID, $systemID)
{
	$result = true;
	
	$backupIDs = array();
	$i = 0;
	foreach ($fileList as $fileInfo) {
		$backupID = (int)$fileInfo['backup_id'];
		// Add unique backupID's to the backup list.
		if (!in_array($backupID, $backupIDs)) {
			$backupIDs[$i++] = $backupID;
		}
	}
	
	$startTime = 0;
	$endTime = time();
	$backupTypes = array("master", "incremental", "selective");
	$result_format = array('backup_ids' => $backupIDs,
						   'type' => $backupTypes,
						   'system_id' => $systemID,
						   'client_id' => $clientID,
						   'start_time' => $startTime,
						   'end_time' => $endTime);

	$backupArray = $BP->get_backup_status($result_format);
	if ($backupArray === false || count($backupArray) == 0) {
		// Since we are not erroring out totally, log in the error log.
		// We either returned an error in backup status, or no status entries returned.
		// The CMC will pick up on the empty Backup Status XML and warn the user.
		global $Log;
		$message = " Could not get backup status for these backup ID's after file search: ";
		foreach ($backupIDs as $backupID) {
			$message .= $backupID . ", ";
		}
		$message .= "\n";
		$message = $BP->getError() . ":" . $message;
		$Log->writeError($message, true);
		$xml->push('BackupStatusArray');
		$xml->pop(); // BackupStatusArray
	} else {	
		$xml->push('BackupStatusArray');
		foreach ($backupArray as $backupInfo) {
			createBackupStatusXML($xml, "BackupStatus", $backupInfo);
		}
		$xml->pop(); // BackupStatusArray
	}
	return $result;
}

function displaySearchList($xml, $BP, $fileList, $systemID)
{
	$xml->push('FilesFoundArray');
	foreach ($fileList as $fileInfo) {
		$dateTime = date('m/d/Y   h:i:s A', $fileInfo['date']);
		// For Linux directories, remove the volume placeholder for the view.
		$viewDirectory = str_replace("@@@:", "", $fileInfo['directory']);   
		$fileSize = is_int($fileInfo['size']) ? $fileInfo['size'] : sprintf("%.2f", $fileInfo['size']);	
		$xml->emptyelement('FileFound', array('Name' => $fileInfo['name'],
											  'View' => $viewDirectory,
											  'id' => $fileInfo['id'],
											  'backup_id' => $fileInfo['backup_id'],
											  'Directory' => $fileInfo['directory'],
											  'Date' => $dateTime,
											  'Size' => $fileSize));
	}
	$xml->pop(); // FilesFoundArray
}

$BP->destroyCookie();
?>
