<?php
// defines BP, xml, action, cookie
require 'header.php';

// set hostInfo Old name and Info to empty array.
$hostOldName = array();
$hostInfo = array();
$oldname = "";
$bChange = false;
$bValid = true;

// see if the dpu ID is provided
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
$localID = $BP->get_local_system_id();

switch ($action) {

	case "list":
		$hosts = $BP->get_host_list($dpuID);
		$hostName = $BP->get_hostname($localID);
		if ($hosts === false || $hostName === false) {
			$bValid = false;
		} else {
			$xml->push("root");
			foreach ($hosts as $name) {
				$hostInfo = $BP->get_host_info($name, $dpuID);
				if ($hostInfo === false) {
					$bValid = false;
					break;
				} else {
					$xml->push("Host", array("Name" => $hostInfo['name']));
					$xml->element('Local', ($hostName['name'] == $hostInfo['name']) ? "1" : "0");
					if (array_key_exists('ip', $hostInfo))
						$xml->element('IP', $hostInfo['ip']);
					if (array_key_exists('long_name', $hostInfo))
						$xml->element('Longname', $hostInfo['long_name']);
					if (array_key_exists('aliases', $hostInfo)) {
						foreach ($hostInfo['aliases'] as $alias) {
							$xml->element('Alias', $alias);
						}
					}
					$xml->pop(); // host
				}
			}
			$xml->pop(); //root
		}
		if (!$bValid) {
			$xml->clear(false);
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
					
	case "update":
	case "change":
		// if updating, must specify original IP address.	
		if (!isset($_GET['originalIP'])) {
			$BP->buildResult($xml, false,
							"The IP address must be specified to update an existing entry.");
			echo($xml->getXml());
			break;
		}

		// set flag for change and fall through to add/save.
		$bChange = true;
		$originalIP = $_GET['originalIP'];		
					
	case "add":	
		// Get the host definition from arguments.
		if (isset($_GET['name'])) {
			$name = $_GET['name'];
			$hostInfo = array ("name" => $name);
			$options = array ('ip' => 'ip',
							  'long_name' => 'longname');
			$bOptions = array();
			$hostInfo = buildOptions($hostInfo, $options, $bOptions);
			
			if (isset($_GET['aliases'])) {			
				$aliasNames = buildAliases($_GET['aliases']);	
				$hostInfo['aliases'] = $aliasNames;	
			}
			
			// If we are changing an existing entry, add the original IP
			// and change in systems list if note local and system is set.
			if ($bChange) {
				$hostInfo['original_ip'] = $originalIP;
				if (($dpuID != $localID) && isset($_GET['system'])) {
					$systemInfo = $BP->get_system_info($sid);
					if ($systemInfo !== false) {
						$systemInfo['host'] = $name;
						// Check to see if we want to update the system name, also.
						if (isset($_GET['sysname'])) {
							$systemInfo['name'] = $name;
						}
						$result = $BP->save_system_info($systemInfo);
						if ($result === false) {
							$bValid = false;
						}
					} else {
						$bValid = false;
					}
				}
			}
			if ($bValid) {
				//$BP->buildResult($xml, $BP->save_host_info($hostInfo, $dpuID));
				$result = $BP->save_host_info($hostInfo, $dpuID);
				$bpError = $BP->getError();
				// See if already present.  If so, okay.
				if ($result === false) {
					$info = $BP->get_host_info($hostInfo['name'], $dpuID);
					if ($info !== false && $info['ip'] == $hostInfo['ip']) {
						$BP->buildResult($xml, true);
					} else {
						// The error is on the save.
						$BP->buildResult($xml, false, $bpError);
					}
				} else {
					$BP->buildResult($xml, true);
				}
			} else {
				$BP->buildResult($xml, false);
			}			
		} else {
			$BP->buildResult($xml, false, "improper argument format; host name must be specified.");				
		}
		echo($xml->getXml());		
		break;
					
	case "delete":
		if (isset($_GET['name'])) {
			$hostName = $_GET['name'];
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$BP->buildResult($xml, $BP->remove_host_info($hostName));
			} else {
				$BP->buildResult($xml, $BP->remove_host_info($hostName, $dpuID));
			}
		} else {
			$stringError = sprintf("improper argument format; must specify a host name for deletion.");
			$BP->buildResult($xml, false, $stringError);
		}
		echo($xml->getXml());
		break;
		
	case "IP":
		$entry = isset($_GET['name']) ? $_GET['name'] : "";
		$hostInfo = $BP->get_host_info(strtolower($entry), $dpuID);
		
		if ($hostInfo !== false) {
			$xml->push("root");
			// kept for backward compatibility
			$xml->element("IP", $hostInfo['ip']);
			
			// added so that the client knows the whole contents of the host file
			// so that changes to the IP address or information for the host
			// does not alter the aliases or destroy alias or client entries.
				$xml->push("Host", array("Name" => $hostInfo['name']));
				if (array_key_exists('ip', $hostInfo))
					$xml->element('IP', $hostInfo['ip']);
				if (array_key_exists('long_name', $hostInfo))
					$xml->element('Longname', $hostInfo['long_name']);
				if (array_key_exists('aliases', $hostInfo)) {
					foreach ($hostInfo['aliases'] as $alias) {
						$xml->element('Alias', $alias);
					}
				}
				$xml->pop();
			$xml->pop();
		} else {
			$BP->buildResult($xml, false, "Unable to find IP Address for " . $entry . ".");
		}
		echo($xml->getXml());
		break;
}

function buildAliases($aliasString)
{
	$aliasNames = array();
	
	// aliases string will be in the form <alias>,<alias>, ...

	$aliasString = trim($aliasString, ",");

	$aliasExploded = explode(",", $aliasString);
	$i = 0;
	foreach ($aliasExploded as $aliasName) {
		$aliasNames[$i++] = $aliasName;	
	}
	
	return $aliasNames;
}

$BP->destroyCookie();
?>
