<?php
// defines BP, xml, action, cookie
require 'header.php';

// defines functions for master.ini processing
require('baseini.php');

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {				
	case "list":
		$queryType = 'sections';
		if (isset($_GET['section'])) {
			$section = $_GET['section'];
			$queryType = 'section';
			if (isset($_GET['field'])) {
				$field = $_GET['field'];
				$queryType = 'field';
			}
		}
		switch ($queryType) {
			case 'sections':
				$sectionsList = $BP->get_ini_sections($dpuID);
				if ($sectionsList != false) {
					$xml->push('root');
					displaySections($xml, $BP, $sectionsList);
					$xml->pop();
				} else {
					$xml->clear(false);
					$BP->buildResult($xml, false);
				}
				break;
			case 'section':
				$xml->push('root');
				displaySection($xml, $BP, $section);
				$xml->pop();
				break;
			case 'field':
				$xml->push('root');
				displayField($xml, $BP, $section, $field);
				$xml->pop();
				break;
		}		
		echo($xml->getXml());
		break;
	
	case "update":
		// to update a field/value pair or add if not present
		$bValid = false;
		if (isset($_GET['section'])) {
			$section = $_GET['section'];
			if (isset($_GET['field'])) {
				$field = $_GET['field'];
				if (isset($_GET['value'])) {
					$value = $_GET['value'];
					$bValid = true;
				} else {
					$BP->buildResult($xml, false, "error: ini.php: no field value specified.");
				}
			} else if (isset($_GET['fvarray'])) {
				$fvArray = buildFVArray($_GET['fvarray']);
				foreach ($fvArray as $field => $value) {
					$result = $BP->set_ini_value($section, $field, $value, $dpuID);
					if ($result !== true) {
						break;
					}
				}
				$BP->buildResult($xml, $result);
			} else {
				$BP->buildResult($xml, false, "error: ini.php: no field name specified.");
			}
		} else {
			$BP->buildResult($xml, false, "error: ini.php no section name specified.");
		}					
		
		if ($bValid) {
			$BP->buildResult($xml, $BP->set_ini_value($section, $field, $value, $dpuID));
		}
		echo($xml->getXml());			
		break;
}

$BP->destroyCookie();
?>
