<?php
// defines BP, xml, action, cookie
require 'header.php';

// function to calculate capacity
require 'systeminfo.php';

//function to get license class description
require 'startupfunctions.php';

// initialize license info arrays.
$licenseInfo = array();

// set DPU id
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {				
	case "list":
			$licenseInfo = $BP->get_license_info($dpuID);
			if ($licenseInfo !== false) {
				$xml->push('root');
				createLicenseXML($BP, $xml, $licenseInfo, $dpuID);
				$xml->pop(); // root
			} else {	
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
			
	case "asset":
			$assetTag = $BP->get_asset_tag($dpuID);
			if ($assetTag !== false) {
				$xml->push('root');
				$xml->element('AssetTag', $assetTag);
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
					
	case "update":
			// update license
			$options = array ('version' => 'version',
							  'serial_number' => 'serial',
							  'user_string' => 'user',
							  'feature_string' => 'feature',
							  'key' => 'key',
							  'expiration_date' => 'exp');
			$bOptions = array();			
			$licenseInfo = buildOptions($licenseInfo, $options, $bOptions);	
			// Set license inputs that do not vary - pass to API until no longer required.
			$licenseInfo['version'] = "6.3.0";
			$licenseInfo['serial_number'] = "D15000";
			$licenseInfo['user_string'] = "150";		
			$result = $BP->save_license_info($licenseInfo, $dpuID);
			$BP->buildResult($xml, $result);
			echo($xml->getXml());			
			break;
			
	case "limit":
			// get the license resource limit
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$licenseLimit = $BP->get_resource_license_limit();
			} else {
				$licenseLimit = $BP->get_resource_license_limit($dpuID);
			}
			if($licenseLimit != false ) {
				$xml->push('root');
					$xml->emptyelement('LicenseLimit', array('vms' => $licenseLimit['vms'],
															'workstations' => $licenseLimit['workstations'],
															'servers' => $licenseLimit['servers'],
															'sockets' => $licenseLimit['sockets'],
															'applications' => $licenseLimit['applications']));
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());			
			break;

	case "usage":
			//get license resource usage
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$licenseUsage = $BP->get_resource_license_usage();
			} else {
				$licenseUsage = $BP->get_resource_license_usage($dpuID);
			}	
			if($licenseUsage != false) {
				$xml->push('root');
				$xml->emptyelement('LicenseUsage', array('vms' => $licenseUsage['vms'],
														'workstations' => $licenseUsage['workstations'],
														'servers' => $licenseUsage['servers'],
														'sockets' => $licenseUsage['sockets'],
														'applications' => $licenseUsage['applications']));
				$xml->pop(); //root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());			
			break;
}

$BP->destroyCookie();
?>
