<?php
// defines BP, xml, action, cookie
require 'header.php';
// set of functions for user management
require 'userfunctions.php';

// set LocationInfo ID to null (for update vs. add)
$locationInfoID = NULL;
$locationInfoName = NULL;

$stringError = NULL;

switch ($action) {
	case "list":	$bValid = true;
					$locationList = $BP->get_location_list();
					if ($locationList === false) {
						$bValid = false;
					} else {
						$xml->push("root");
						foreach ($locationList as $locationID => $locationName) {
							$locationInfo = $BP->get_location_info($locationID);
							if ($locationInfo === false) {
								$bValid = false;
								break;
							}
							$xml->push("Location", array("Name" => $locationName, "ID" => $locationID));
							$xml->element("Where", $locationName);
							if (array_key_exists('latitude', $locationInfo) && $locationInfo['latitude'] != 0) {
								$xml->element("Latitude", $locationInfo['latitude']);
							} else {
								$xml->element("Latitude", "");
							}
							
							if (array_key_exists('longitude', $locationInfo) && $locationInfo['longitude'] != 0) {
								$xml->element("Longitude", $locationInfo['longitude']);
							} else {
								$xml->element("Longitude", "");
							}
							$xml->push("Customer", array("Name" => $locationInfo['customer_name'],
															"ID" => $locationInfo['customer_id']));
							$xml->pop(); // customer
							$xml->pop(); // location
						}
						$xml->pop(); // root
					}
					if (!$bValid) {
						$xml->clear(false);
						$BP->buildResult($xml, false);
					}
					echo($xml->getXml());
					break;
					
	case "update":	// if updating, specify id or map location and customer name to location ID
					if (isset($_GET['id'])) {
						$locationID = (int)$_GET['id'];
						$locationInfoID = array("id" => $locationID);
					}
					// fall through to add.
	
	case "add":		if (isset($_GET['name'])) {
						$name = $_GET['name'];
						$locationInfoName = array("name" => $name);
					}
					
					if ($locationInfoID == NULL && $locationInfoName == NULL) {
						$BP->buildResult($xml, false, "error: locations.php: no location name or id specified.");
						echo($xml->getXml());
					} else {
						if ($locationInfoID != NULL && $locationInfoName != NULL) {
							$locationInfo = array_merge($locationInfoID, $locationInfoName);
						} else if ($locationInfoID == NULL && $locationInfoName != NULL) {
							$locationInfo = $locationInfoName;
						} else if ($locationInfoID != NULL && $locationInfoName == NULL) {
							$locationInfo = $locationInfoID;
						}
						
						if (isset($_GET['customer_id']) || isset($_GET['customer_name'])) {				
							if (isset($_GET['customer_id'])) {
								$customerID = (int)$_GET['customer_id'];
							} else {
								$customerName = $_GET['customer_name'];
								$customerID = getCustomerIDFromName($BP, $customerName);
								// surmise the locationID from customer/location names.
								if ($locationInfoID == NULL && isset($_GET['customer_name']) && isset($_GET['name'])) {
									$customerName = $_GET['customer_name'];
									$locationName = $_GET['name'];
									$locationID = getLocationIDFromName($BP, $locationName, $customerName);
									if ($locationID != -1) {
										$locationInfo = array_merge(array("id" => $locationID), $locationInfo);
									}
								}
							}
							$locationInfo = array_merge($locationInfo, array ("customer_id" => $customerID));
						}									
						if (isset($_GET['latitude'])) {
							$latitude = (float)$_GET['latitude'];
							$locationInfo = array_merge($locationInfo, array ("latitude" => $latitude));
						}
						if (isset($_GET['longitude'])) {
							$longitude = (float)$_GET['longitude'];
							$locationInfo = array_merge($locationInfo, array ("longitude" => $longitude));
						}
						if (array_key_exists("id", $locationInfo) && isset($_GET['new_name'])) {
							$newName = $_GET['new_name'];
							$locationInfo['name'] = $newName;
						}
						
						if ($stringError == NULL) {
							$BP->buildResult($xml, $BP->save_location_info($locationInfo));
							echo($xml->getXml());
						} else {
							$BP->buildResult($xml, false, $stringError);
							echo($xml->getXml());
						}
					}				
					break;
					
	case "delete":	if (isset($_GET['id'])) {
						$locationID = (int)$_GET['id'];
					} else {
						// user specified name, translate to ID.
						$locationName = $_GET['name'];
						$customerName = $_GET['customer_name'];
								
						$locationID = getLocationIDFromName($BP, $locationName, $customerName);
					}
					if ($locationID != -1) {
						$BP->buildResult($xml, $BP->remove_location($locationID));
						echo($xml->getXml());
					} else {
						$stringError = sprintf("error: locations.php: could not determine location ID for location %s, customer %s.",
													$locationName, $customerName);
						$BP->buildResult($xml, false, $stringError);
						echo($xml->getXml());
					}
					break;
}

$BP->destroyCookie();
?>
