<?php
// defines BP, xml, action, cookie
require 'header.php';

// storagefunctions
require 'functions/storagefunctions.php';

$Storage = new StorageFunctions();

// set dpu ID
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {
		
	case "list":
		// list the available storage and disks in the LVM.
		$internalList = $BP->get_internal_storage_list($dpuID);
		$storageList = $BP->get_storage_list($dpuID);
		$lvmPartitions = $BP->get_lvm_disks();
		$lvmInfo = $BP->get_lvm_info();
		
		if ($internalList !== false) {
			$xml->push("root");
			foreach ($internalList as $storage) {
				// make sure the internal disk is not used for other purposes and
				// is not already part of the LVM.
				if (!$Storage->inLVM($BP, $storage, $lvmPartitions, $lvmInfo, $dpuID) &&
					!$Storage->isAllocated($BP, $storage, $storageList, $dpuID)) {
					$xml->element('Internal', $storage);
				}
			}
			foreach ($lvmPartitions as $disk) {
				$xml->element('LVM', $disk);
			}	
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
	
	case "add":
		// Grow the LVM to use the specified disk.
		if (isset($_GET['disks'])) {
			$disks = $_GET['disks'];
			if ($disks != "") {
				$diskList = explode(',', $disks);
				if (count($diskList) > 0) {
					$result = true;
					foreach ($diskList as $disk) {
						$partitions = $BP->grow_lvm_partitions($disk);
						if ($partitions === false) {
							$error = $BP->getError();
							if (strpos($error, "Already used") != false) {
								// This is okay.  It means that the storage is already
								// being used as another storage.
								//sleep(2);
							} else {
								$result = false;
								break;
							}
						}
					}
					$BP->buildResult($xml, $result);
				} else {
					// No disks to add; don't fail.
					$BP->buildResult($xml, true);
				}
			} else {
				// No disks to add; don't fail.
				$BP->buildResult($xml, true);
			}
		} else {
			$BP->buildResult($xml, false, 'must provide disk to expand protected space.');
		}
		echo($xml->getXml());
		break;

	case "info":
		$lvmInfo = $BP->get_lvm_info();
		if ($lvmInfo !== false ) {
			$xml->push("root");
			$xml->element('Total', $lvmInfo['gb_size']);
			$xml->element('Free', $lvmInfo['gb_free']);
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;
	case "partition_info":
		$lvmInfo = $BP->get_lvm_partition_info();
		if ($lvmInfo !== false ) {
			$xml->push("root");
			$xml->element('Backups', $lvmInfo['backups']);
			$xml->element('Database', $lvmInfo['database']);
			$xml->element('Swap', $lvmInfo['swap']);
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		
		break;
}

$BP->destroyCookie();
?>