<?php
// defines BP, xml, action, cookie
require 'header.php';


$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {

	case "isserver":
		// run this on the server (vault, manager).
		$configured = $BP->is_openvpn_server_configured();
		if ($configured !== -1) {
			$xml->push("root");
			$xml->element("Configured", $configured == true ? "1" : "0");
			if ($configured) {
				$result = $BP->get_openvpn_server_info();
				if ($result !== true) {
					if (isset($result['network'])) {
						$xml->element("Network", $result['network']);
					}
					if (isset($result['mask'])) {
						$xml->element("Mask", $result['mask']);
					}
					if (isset($result['port'])) {
						$xml->element("Port", $result['port']);
					}
				}
			}
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		break;
					
		// run this on the server (vault, manager).
	case "server":
		$ip = $_GET['ip'];
		$mask = $_GET['mask'];
		$port = (int)$_GET['port'];
		$BP->buildResult($xml, $BP->configure_openvpn_server($ip, $mask, $port));
		break;
			
		// run this on the client (DPU)
	case "request":	
		$cert = $BP->request_openvpn_cert();
		if ($cert !== false) {
			$xml->push("root");
			$xml->push("Certificate");
			if (isset($cert['fname'])) {
				$xml->element("Filename", $cert['fname']);
			}
			if (isset($cert['contents'])) {
				$xml->push("Contents");
				$xml->cData($cert['contents']);
				$xml->pop(); // Contents
			}
			$xml->pop(); // Certificate
			$xml->pop(); //root
		} else {
			$BP->buildResult($xml, false);
		}
		break;

	case "sign":
		// run this on the server (vault, manager).
		$csr = $_REQUEST['csr'];
		$client = $_GET['client'];		// hostname of the DPU (client)
		$bRevoke = isset($_GET['revoke']) ? $_GET['revoke'] == '1' : false;
		$result = $BP->sign_openvpn_cert($client, $csr, $bRevoke);
		if ($result !== false) {
			$xml->push("root");
			// Client cert
			if (isset($result['client_cert'])) {
				$cert = $result['client_cert'];
				$xml->push("Client");
				if (isset($cert['fname'])) {
					$xml->element("Filename", $cert['fname']);
				}
				if (isset($cert['contents'])) {
					$xml->push("Contents");
					$xml->cData($cert['contents']);
					$xml->pop(); // Contents
				}
				$xml->pop(); // Client
			}
			
			// CA cert
			if (isset($result['ca_cert'])) {
				$cert = $result['ca_cert'];
				$xml->push("CA");
				if (isset($cert['fname'])) {
					$xml->element("Filename", $cert['fname']);
				}
				if (isset($cert['contents'])) {
					$xml->push("Contents");
					$xml->cData($cert['contents']);
					$xml->pop(); // Contents
				}
				$xml->pop(); // CA
			}
			$xml->pop(); // root
		} else {
			$BP->buildResult($xml, false);
		}
		break;
								
	case "client":
		// run this on the client (DPU).
		$ca = $_REQUEST['ca'];
		$cert = $_REQUEST['cert'];
		$server = $_GET['server'];
		$port = (int)$_GET['port'];
		$BP->buildResult($xml, $BP->configure_openvpn_client($ca, $cert, $server, $port));
		break;
}

echo($xml->getXml());

$BP->destroyCookie();
?>
