<?php
//
// RSS writer class, calls the member variable xml writer to build RSS structures.
//
class rssWriter {
	
    var $m_xml;
	var $m_version;
	var $m_link;
	var $m_url;
	var $m_imageDir;
	
    function __construct($xml, $version = NULL) {
		$this->m_xml = $xml;
		$this->m_version = ($version != NULL) ? $version : "2.0";
		$this->start();
		$http = 'http://';
		$serverAddress = $_SERVER['SERVER_ADDR'];
		$this->m_url = $http . $serverAddress;
		$imageDir = $this->m_url . '/recoveryconsole/bpl/rss/';
		$this->m_imageDir = $imageDir;
		$this->m_image_url = $this->m_imageDir . 'logo.jpg';
    }
	
	function __destruct() {
	}
	
	function start() {
		$attributes = array("version" => $this->m_version);
		$this->m_xml->push("rss", $attributes);
	}
	
	function openChannel($title, $link, $description, $image = NULL) {
		$this->m_xml->push("channel");
		$this->m_link = $link;
		$this->rssContent($title, $link, $description);
		$this->image($image);
	}
	
	function item($title, $link, $description) {
		$this->m_xml->push("item");
		$this->itemContent($title, $link, $description);
		$this->m_xml->pop();
	}
	
	function openItem($attributes) {
		if (isset($attributes['title'])) {
			$title = $attributes['title'];
		} else {
			$title = $attributes['ClientName'];
		}
		//$link = $this->m_link;
		$link = NULL;
		if (isset($attributes['description'])) {
			$description = $attributes['description'];
		} else {
			$description = $attributes['Type'];
		}		
		$this->m_xml->push("item");
		$this->rssContent($title, $link, $description);
		foreach ($attributes as $name => $value) {
			$this->m_xml->element($name, $value);
		}
	}
	
	function rssContent($title, $link, $description) {
		$this->m_xml->element("title", $title);
		if ($link != NULL) {
			$this->m_xml->element("link", $link);
		}
		$this->m_xml->element("description", $description);
	}
	
	function image($image = NULL) {
		$this->m_xml->push("image");
		$url = ($image == NULL) ? $this->m_image_url : $image;
		$this->m_xml->element('url', $url);
		$this->m_xml->element('title', 'Unitrends');
		$this->m_xml->element('link', $this->m_link);
		$this->m_xml->pop();
	}
	
	function getImageURL() {
		return $this->m_image_url;
	}
	
	
	function getURL() {
		return $this->m_url;
	}
	
	function closeItem() {
		$this->pop();
	}
	
	function closeChannel() {
		$this->pop();
	}
	
	function finish() {
		$this->pop();
	}
	
	function pop() {
		$this->m_xml->pop();
	}
 
}
?>