<?php
// defines BP, xml, action, cookie
require 'header.php';

// general backup list operations.
require 'listsbase.php';
$ListBase = new ListBase();

// Initialize variables to be used in copy and save.
$selectionInfo = array();
$bValid = true;
$bCopy = false;

switch ($action) {

	case "list":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$ListBase->buildSelectionLists($BP, $xml, $dpuID);
			echo($xml->getXml());
			break;
					
	case "load":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();						
			if (($id = $ListBase->getID($BP, 'get_selection_lists', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find selection list for loading.");
			} else {
				$selectionList = $BP->get_selection_list($id, $dpuID);
				if ($selectionList === false) {
					$BP->buildResult($xml, false);
				} else {
					$xml->push("root");
					if (array_key_exists('metanames', $selectionList)) {
						$metanames = $selectionList['metanames'];
						foreach ($metanames as $exclusionName) {
							$xml->element("Metaname", $exclusionName);
						}
					}
					if (array_key_exists('filenames', $selectionList)) {
						$filenames = $selectionList['filenames'];
						foreach ($filenames as $fileName) {
							// For Linux directories, remove the volume placeholder.
							$fileName = str_replace(LINUX_VOLUME, "", $fileName); 
							$xml->element("Filename", $fileName);
						}
					}
					$xml->pop(); // root
				}
			}
			echo($xml->getXml());
			break;
			
	case "copy":
			$bValid = false;
			$bCopy = true;
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			$originalID = (int)$_GET['oid'];	
			$selectionLists = $BP->get_selection_lists($dpuID);			
			if ($selectionLists === false) {
				$BP->buildResult($xml, false);
			} else {
				foreach ($selectionLists as $selectionList) {
					if ($selectionList['id'] == $originalID) {
						$selectionInfo = $selectionList;
						$contents = $BP->get_selection_list($originalID, $dpuID);
						if ($contents === false) {
							$BP->buildResult($xml, false);
						} else {
							if (array_key_exists('metnames', $contents)) {
								$selectionInfo['metanames'] = $contents['metanames'];
							}
							if (array_key_exists('filenames', $contents)) {
								$selectionInfo['filenames'] = $contents['filenames'];
							}
							$bValid = true;
						}
						break;
					}
				}
			}		
			// Fall through to save the constructed calendar copy.	
					
	case "save":
			if ($bValid) {	
				$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
				$id = $ListBase->getID($BP, 'get_selection_lists', $dpuID);
				if ($id == -1) {
					if (isset($_GET['name'])) {
						$selectionInfo = array_merge($selectionInfo, array("name" => $_GET['name']));
					} else {
						$BP->buildResult($xml, false, "Error: must specify either name or id of list to save.");
						$bValid = false;
					}
				} else {
					$selectionInfo = array("id" => $id);
					if (isset($_GET['name'])) {
						$selectionInfo = array_merge($selectionInfo, array("name" => $_GET['name']));
					}
				}
			}
			if ($bValid) {
				if ($bCopy) {
					unset($selectionInfo['id']);
					$selectionInfo['read_only'] = false;
				} else {											
					$options = array ('description' => 'desc',
									  'type' => 'stype',
									  'family' => 'family');
					$bOptions = array('read_only' => 'ro');		
					$selectionInfo = buildOptions($selectionInfo, $options, $bOptions);
				
					if (isset($_REQUEST['files'])) {
						$fileList = $_REQUEST['files'];
						if ($fileList != "") {
							$filenames = explode(",", $fileList);
							for ($i = 0; $i < count($filenames); $i++) {
								$filenames[$i] = urldecode($filenames[$i]);					
							}
							$selectionInfo['filenames'] = $filenames;
						} else {
							$selectionInfo['filenames'] = array();
						}
					}
					if (isset($_REQUEST['meta'])) {
						$metaList = $_REQUEST['meta'];
						if ($metaList != "") {
							$metanames = explode(",", $metaList);
							$selectionInfo['metanames'] = $metanames;
						} else {
							$selectionInfo['metanames'] = array();
						}
					}
				}
				$ListBase->buildListResult($xml, $BP->save_selection_list($selectionInfo, $dpuID));
			}
			echo($xml->getXml());			
			break;
				
	case "delete":
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (($id = $ListBase->getID($BP, 'get_selection_lists', $dpuID)) == -1) {
				$BP->buildResult($xml, false, "Error: cannot find identifier for deleting selection list.");
			} else {
				$BP->buildResult($xml, $BP->delete_selection_list($id, $dpuID));
			}
			echo($xml->getXml());
			break;
}

$BP->destroyCookie();
?>