<?php
// defines BP, xml, action, cookie
require 'header.php';

$localID = $BP->get_local_system_id();
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $localID;

// figure out which sysID to used based on view.
$sysID = $grandClientView ? $localID : $dpuID;

switch ($action) {

	case "list":	// list exchange information
			$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
			$appID = isset($_GET['aid']) ? (int)$_GET['aid'] : -1;
			$bCache = isset($_GET['cache']) ? true : false;
			$bIsSupported = $BP->is_appconfig_supported($dpuID);
			
			if ($grandClientView) {
				$grandClientSqlInfo = $BP->get_grandclient_sql_info($clientID, $appID);
				$sqlInfo = false;
			} else {
				$sqlInfo = $BP->get_sql_info($clientID, $appID, $bCache, $dpuID);
				$grandClientSqlInfo = false;
			}
			
			if ($sqlInfo !== false) {
				$xml->push("root");
				foreach ($sqlInfo as $sqlItem) {
					$xml->push('SQL', array("Identification" => $sqlItem['instance_id'],
											"Instance" => $sqlItem['instance'],
											"Database" => $sqlItem['database'],
											"Model" => $sqlItem['recovery_model']));
					if (isset($sqlItem['online'])) {
						$xml->element('Online', $sqlItem['online'] ? '1' : '0');
					}
					
					// test if dpu has priority/sync functionality, if not return -1	
					if ($bIsSupported) {
						if (isset($sqlItem['priority'])) {
							$priority = $sqlItem['priority'];
							$xml->element('Priority', $priority);
						}
						if (isset($sqlItem['is_synchable'])) {
							$xml->element('Synchable', $sqlItem['is_synchable'] ? '1' : '0');
						}
					}
					// If pulling from the cache, is fast, so get whether a system DB.
					if ($bCache == true) {
						if (isset($sqlItem['wvf'])) {
							$xml->element('WVF', $sqlItem['wvf'] ? '1' : '0');
							$instanceID = (int)$sqlItem['instance_id'];
							$systemDB = $BP->is_sql_system_db($instanceID, $dpuID);
							$xml->element('SystemDB', $systemDB == true ? "1" : "0");
						}
					}
					$xml->pop(); //SQL
				}
				$xml->element('Supported', $bIsSupported == true ? 1 : 0);
				$xml->pop();
			} else if ($grandClientSqlInfo !== false) {
				$xml->push("root");
				foreach ($grandClientSqlInfo as $sqlItem) {
					$xml->push('SQL', array("Identification" => $sqlItem['instance_id'],
											"Instance" => $sqlItem['instance'],
											"Database" => $sqlItem['database']));
					$xml->pop(); //SQL
				}
				$xml->element('Supported', $bIsSupported == true ? 1 : 0);
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}
								
			echo($xml->getXml());			
			break;
		
	case "clients":	// list restore clients based on instance ID.
			$instanceID = isset($_GET['id']) ? (int)$_GET['id'] : -1;
			$sqlClients = $BP->get_sql_server_recovery_clients($instanceID, $sysID);
			if ($sqlClients !== false) {
				$xml->push("root");
				if (isset($sqlClients['app_name'])) {
					$xml->emptyElement('Application', array("Name" => $sqlClients['app_name']));
				}
				if (isset($sqlClients['clients'])) {
					$restoreClients = $sqlClients['clients'];
					if (count($restoreClients) > 0) {
						foreach ($restoreClients as $id => $name) {
							$xml->emptyElement('Client', array("Identification" => $id, "Name" => $name));
						}
					}
				}
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}					
			echo($xml->getXml());			
			break;
			
	case "target":	// list restore targets based on client and instanceID.
			$clientID = isset($_GET['cid']) ? (int)$_GET['cid'] : -1;
			$instanceID = isset($_GET['id']) ? (int)$_GET['id'] : -1;
			$sqlInfo = $BP->get_sql_server_recovery_targets($clientID, $instanceID, $sysID);
			if ($sqlInfo !== false) {
				$xml->push("root");
				foreach ($sqlInfo as $recoveryItem) {
					$name = $recoveryItem['name'];
					$bRunning = $recoveryItem['is_running'];
					$xml->push('Instance', array("Name" => $name));
					$xml->element('Running', $bRunning ? '1' : '0');
					$xml->pop();
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}					
			echo($xml->getXml());			
			break;
			
	case "system":	// see if the given app instance is a system database.
			$instanceID = isset($_GET['id']) ? (int)$_GET['id'] : -1;
			$result = $BP->is_sql_system_db($instanceID, $sysID);
			if ($result !== -1) {
				$xml->push("root");
				$xml->element('SystemDB', $result == true ? "1" : "0");
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}					
			echo($xml->getXml());			
			break;
			
}

$BP->destroyCookie();
?>