<?php
// defines BP, xml, action, cookie
require 'header.php';

// wir supported utility
require $rootdir . 'bpl/tools/wir_supported_util.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {

	case "list":	// list storage
			$d2d = $BP->get_d2d($dpuID);
			if ($d2d !== false) {
				$xml->push("root");
				displayStorage($xml, 'D2D', $d2d);
				$vc = $BP->get_vc($dpuID);
				if ($vc !== false) {
					displayStorage($xml, 'VC', $vc);
				}
				// Virtual Failover NVP setting is supported if:
				//
				// 1) Virtual clients (WVF) is supported on the platform.
				// 2) VMware IR is supported on the platform.
				//
				$virtual_clients_supported = $BP->virtual_clients_supported($dpuID);
				$bVF = isWIROnApplianceSupported($virtual_clients_supported);
				if ($bVF !== true) {
					$bVF = ($BP->vmware_ir_supported($dpuID) || $BP->hyperv_ir_supported($dpuID));
				}
				if ($bVF == true) {
					$vf = $BP->get_virtual_failover($dpuID);
					if ($vf !== false) {
						displayStorage($xml, 'VirtualFailover', $vf);
					}
				}
				$reserve = $BP->get_customer_reserve($dpuID);
				if ($reserve !== false) {
					displayStorage($xml, 'Reserve', $reserve);
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}					
			echo($xml->getXml());			
			break;
			
	case "d2d":	// update D2D storage allowed
			if (isset($_GET['allowed'])) {		
				// update D2D first.
				$allowed = (float)$_GET['allowed'];
				$result = $BP->set_d2d($allowed, $dpuID);

				// if vf present, also set it.
				if ($result !== false && isset($_GET['vf'])) {
					$allowed = (float)$_GET['vf'];
					$result = $BP->set_virtual_failover($allowed, $dpuID);
				}
				// if vc present, also set it.
				if ($result !== false && isset($_GET['vc'])) {
					$allowed = (float)$_GET['vc'];
					$result = $BP->set_vc($allowed, $dpuID);
				}
				
				// Return success or failure based on set APIs.
				$BP->buildResult($xml, $result !== false ? true : false);
			} else {
				$BP->buildResult($xml, false, "must specify D2D allowed value");
			}
			echo($xml->getXml());			
			break;
			
	case "vc":	// update VC storage allowed
			if (isset($_GET['allowed'])) {
				// update D2D first.
				$allowed = (float)$_GET['allowed'];
				$result = $BP->set_vc($allowed, $dpuID);

				// if vf present, also set it.
				if ($result !== false && isset($_GET['vf'])) {
					$allowed = (float)$_GET['vf'];
					$result = $BP->set_virtual_failover($allowed, $dpuID);
				}
				// if vc present, also set it.
				if ($result !== false && isset($_GET['d2d'])) {
					$allowed = (float)$_GET['d2d'];
					$result = $BP->set_d2d($allowed, $dpuID);
				}
				
				// Return success or failure based on set APIs.
				$BP->buildResult($xml, $result !== false ? true : false);
			} else {
				$BP->buildResult($xml, false, "must specify VC allowed value");
			}
			echo($xml->getXml());			
			break;
			
	case "vf":		// Update vf storage
			if (isset($_GET['vf'])) {
				// update VF
				$allowed = (float)$_GET['vf'];
				$result = $BP->set_virtual_failover($allowed, $dpuID);
				$BP->buildResult($xml, $result !== false ? true : false);
			} else {
				$BP->buildResult($xml, false, "must specify virtual failover allowed value");
			}
			echo($xml->getXml());			
			break;
			
	case "reserve":	// update reserved storage allowed
			if (isset($_GET['allowed'])) {
				$allowed = (float)$_GET['allowed'];
				//$BP->buildResult($xml, $BP->set_vc($allowed, $dpuID));
				$result = $BP->set_customer_reserve($allowed, $dpuID);
				if ($result === false) {
					$BP->buildResult($xml, false);
				} else {
					$BP->buildResult($xml, true);
				}
			} else {
				$BP->buildResult($xml, false, "must specify value for reserved space");
			}
			echo($xml->getXml());			
			break;

}

function displayStorage($xml, $tag, $storage)
{
	$xml->push($tag);
	if (array_key_exists('low', $storage)) {
		$xml->element('Low', $storage['low']);
	}
	if (array_key_exists('high', $storage)) {
		$xml->element('High', $storage['high']);
	}
	if (array_key_exists('allowed', $storage)) {
		$xml->element('Allowed', $storage['allowed']);
	}
	if (array_key_exists('existing', $storage)) {
		$xml->element('Existing', $storage['existing']);
	}
	if (array_key_exists('licensed', $storage)) {
		$xml->element('Licensed', $storage['licensed']);
	}
	$xml->pop();
}

$BP->destroyCookie();
?>
