<?php

function xmlToClient($xml)
{
	$parser = xml_parser_create();
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct($parser, $xml, $values, $tags);
	xml_parser_free($parser);

	$clientArray = array();
	$oneClient = array();

	$stack = array();
	$i = 0;
	foreach ($values as $val) {
		if ($val['type'] == "open") {
			if ($val['tag'] != "root") {
				$field = buildFieldName($val['tag']);
				array_push($stack, $field);
			}
		} else if ($val['type'] == "close") {
			if ($val['tag'] != "root") {
				array_pop($stack);
			}
			if ($val['tag'] == 'Client') {
				$clientArray[$i++] = $oneClient;
				$oneClient = array();
			}
		} else if ($val['type'] == "complete") {
			$field = buildFieldName($val['tag']);
			array_push($stack, $field);
			setArrayValue($oneClient, $stack, $val['value']);
			array_pop($stack);
		}
	}
	
	$returnArray = array();
	$i = 0;
	foreach ($clientArray as $client) {
		$returnArray[$i++] = $client['Client'];
	}

	return $returnArray;
}

function setArrayValue(&$array, $stack, $value) {
	if ($stack) {
		$key = array_shift($stack);
		setArrayValue($array[$key], $stack, $value);
	} else {
		$array = (int)$value;
	}
}

function buildFieldName($tag)
{
	$field = "";

	switch ($tag) {
		case "ID":
			$field = "id";
			break;
		case "Priority":
			$field = "priority";
			break;
		case "Inclusions":
			$field = "inclusions";
			break;
		case "Exclusions":
			$field = "exclusions";
			break;
		case "Options":
			$field = "options";
			break;
		case "Master":
			$field = "master";
			break;
		case "Incremental":
			$field = "incremental";
			break;
		case "Differential":
			$field = "differential";
			break;
		case "Selective":
			$field = "selective";
			break;
		case "BareMetal":
			$field = "baremetal";
			break;
		default:
			$field = $tag;
			break;
	}

	return $field;
}

?>